#!/usr/bin/env python3

import json
import pprint

import tornado.web
import tornado.ioloop
import tornado.websocket


ADDRESS = "localhost"
PORT = 8080
PATH = "/websocket"

SUBPROTOCOL = "v1.server.status.torlan.ru"

class StatusReporterHandler(tornado.websocket.WebSocketHandler):
    def select_subprotocol(self, subprotocols):
        if SUBPROTOCOL in subprotocols:
            return SUBPROTOCOL

    def open(self):
        print("server connected!")

    def on_close(self):
        print("server disconnected!")

    def on_message(self, message):
        pprint.pprint(json.loads(message))

def main():
    application = tornado.web.Application([
        (PATH, StatusReporterHandler),
    ])
    application.listen(PORT, ADDRESS)
    print("Listening on ws://{}:{}{}".format(ADDRESS, PORT, PATH))
    tornado.ioloop.IOLoop.instance().start()

if __name__ == "__main__":
    main()
